# YOLOv5 ğŸš€ by Ultralytics, AGPL-3.0 license
"""
Run YOLOv5 detection inference on images, videos, directories, globs, YouTube, webcam, streams, etc.

Usage - sources:
    $ python detect.py --weights yolov5s.pt --source 0                               # webcam
                                                     img.jpg                         # image
                                                     vid.mp4                         # video
                                                     screen                          # screenshot
                                                     path/                           # directory
                                                     list.txt                        # list of images
                                                     list.streams                    # list of streams
                                                     'path/*.jpg'                    # glob
                                                     'https://youtu.be/Zgi9g1ksQHc'  # YouTube
                                                     'rtsp://example.com/media.mp4'  # RTSP, RTMP, HTTP stream

Usage - formats:
    $ python detect.py --weights yolov5s.pt                 # PyTorch
                                 yolov5s.torchscript        # TorchScript
                                 yolov5s.onnx               # ONNX Runtime or OpenCV DNN with --dnn
                                 yolov5s_openvino_model     # OpenVINO
                                 yolov5s.engine             # TensorRT
                                 yolov5s.mlmodel            # CoreML (macOS-only)
                                 yolov5s_saved_model        # TensorFlow SavedModel
                                 yolov5s.pb                 # TensorFlow GraphDef
                                 yolov5s.tflite             # TensorFlow Lite
                                 yolov5s_edgetpu.tflite     # TensorFlow Edge TPU
                                 yolov5s_paddle_model       # PaddlePaddle
"""

import argparse
import csv
import os
import platform
import sys
from pathlib import Path
import glob
import numpy as np
import pickle
import torch

FILE = Path(__file__).resolve()
ROOT = FILE.parents[0]  # YOLOv5 root directory
if str(ROOT) not in sys.path:
    sys.path.append(str(ROOT))  # add ROOT to PATH
ROOT = Path(os.path.relpath(ROOT, Path.cwd()))  # relative

from models.common import DetectMultiBackend
from utils.dataloaders import IMG_FORMATS, VID_FORMATS, LoadImages, LoadScreenshots, LoadStreams
from utils.general import (LOGGER, Profile, check_file, check_img_size, check_imshow, check_requirements, colorstr, cv2,
                           increment_path, non_max_suppression, print_args, scale_boxes, strip_optimizer, xyxy2xywh)
from utils.torch_utils import select_device, smart_inference_mode

'''集成跟踪模块，输出跟踪结果文件 .npy'''
# from ultralytics.engine.results import Boxes    # Results
# from ultralytics.utils import IterableSimpleNamespace, yaml_load
from tracking.utils.plotting import Annotator, colors
from tracking.utils import Boxes, IterableSimpleNamespace, yaml_load, boxes_add_fid
from tracking.trackers import BOTSORT, BYTETracker
from tracking.utils.showtrack import drawtracks


def init_trackers(tracker_yaml = None, bs=1):
    """
    Initialize trackers for object tracking during prediction.
    """   
    # 需要将配置文件中的cmc_method改为gmc_method
    # tracker_yaml = r"D:\DeepLearning\ultralytics\ultralytics\tracker\cfg\botsort.yaml"   
    
    tracker_yaml = r"./tracking/trackers/cfg/botsort.yaml"
    
    TRACKER_MAP = {'bytetrack': BYTETracker, 'botsort': BOTSORT}
    
    cfg = IterableSimpleNamespace(**yaml_load(tracker_yaml))
    trackers = []
    for _ in range(bs):
        tracker = TRACKER_MAP[cfg.tracker_type](args=cfg, frame_rate=30)
        trackers.append(tracker)
    
    return trackers


@smart_inference_mode()
def run(
        weights=ROOT / 'yolov5s.pt',  # model path or triton URL
        source=ROOT / 'data/images',  # file/dir/URL/glob/screen/0(webcam)
        data=ROOT / 'data/coco128.yaml',  # dataset.yaml path
        imgsz=(640, 640),  # inference size (height, width)
        conf_thres=0.25,  # confidence threshold
        iou_thres=0.45,  # NMS IOU threshold
        max_det=1000,  # maximum detections per image
        device='',  # cuda device, i.e. 0 or 0,1,2,3 or cpu
        view_img=False,  # show results
        save_txt=False,  # save results to *.txt
        save_csv=False,  # save results in CSV format
        save_conf=False,  # save confidences in --save-txt labels
        save_crop=False,  # save cropped prediction boxes
        nosave=False,  # do not save images/videos
        classes=None,  # filter by class: --class 0, or --class 0 2 3
        agnostic_nms=False,  # class-agnostic NMS
        augment=False,  # augmented inference
        visualize=False,  # visualize features
        update=False,  # update all models
        project=ROOT / 'runs/detect',  # save results to project/name
        name='exp',  # save results to project/name
        exist_ok=False,  # existing project/name ok, do not increment
        line_thickness=3,  # bounding box thickness (pixels)
        hide_labels=False,  # hide labels
        hide_conf=False,  # hide confidencesL
        half=False,  # use FP16 half-precision inference
        dnn=False,  # use OpenCV DNN for ONNX inference
        vid_stride=1,  # video frame-rate stride
):
    source = str(source)
    save_img = not nosave and not source.endswith('.txt')  # save inference images
    is_file = Path(source).suffix[1:] in (IMG_FORMATS + VID_FORMATS)
    is_url = source.lower().startswith(('rtsp://', 'rtmp://', 'http://', 'https://'))
    webcam = source.isnumeric() or source.endswith('.streams') or (is_url and not is_file)
    screenshot = source.lower().startswith('screen')
    if is_url and is_file:
        source = check_file(source)  # download
    
    save_dir = Path(project) / Path(source).stem
    if save_dir.exists():
        print(Path(source).stem)
        # return
        
        save_dir = increment_path(Path(project) / name, exist_ok=exist_ok)  # increment run
        (save_dir / 'labels' if save_txt else save_dir).mkdir(parents=True, exist_ok=True)  # make dir
    else:
        save_dir.mkdir(parents=True, exist_ok=True) 
        
    # Load model
    device = select_device(device)
    model = DetectMultiBackend(weights, device=device, dnn=dnn, data=data, fp16=half)
    stride, names, pt = model.stride, model.names, model.pt
    imgsz = check_img_size(imgsz, s=stride)  # check image size
     
    # Dataloader
    bs = 1  # batch_size
    
    dataset = LoadImages(source, img_size=imgsz, stride=stride, auto=pt, vid_stride=vid_stride)    
    vid_path, vid_writer = [None] * bs, [None] * bs
   
    
    # Run inference
    model.warmup(imgsz=(1 if pt or model.triton else bs, 3, *imgsz))  # warmup
    seen, windows, dt = 0, [], (Profile(), Profile(), Profile())

    
    ## ================================================================================== writed by WQG
    tracker = init_trackers(bs)[0]
    vid_path_track, vid_writer_track = [None] * bs, [None] * bs
    tboxes = []
    vboxes = []
    
    f_i = 1
    for path, im, im0s, vid_cap, s in dataset:
        if f_i == 1: 
            f_i == 0
            imgshow = im0s.copy()
        
        ## ============================= tracking 功能只处理视频，writed by WQG
        if dataset.mode == 'image':
            continue

        with dt[0]:
            im = torch.from_numpy(im).to(model.device)
            im = im.half() if model.fp16 else im.float()  # uint8 to fp16/32
            im /= 255  # 0 - 255 to 0.0 - 1.0
            if len(im.shape) == 3:
                im = im[None]  # expand for batch dim

        # Inference
        with dt[1]:
            visualize = increment_path(save_dir / Path(path).stem, mkdir=True) if visualize else False
            pred = model(im, augment=augment, visualize=visualize)

        # NMS
        with dt[2]:
            pred = non_max_suppression(pred, conf_thres, iou_thres, classes, agnostic_nms, max_det=max_det)

        # Second-stage classifier (optional)
        # pred = utils.general.apply_classifier(pred, classifier_model, im, im0s)

        # Define the path for the CSV file
        csv_path = save_dir / 'predictions.csv'

        # Create or append to the CSV file
        def write_to_csv(image_name, prediction, confidence):
            data = {'Image Name': image_name, 'Prediction': prediction, 'Confidence': confidence}
            with open(csv_path, mode='a', newline='') as f:
                writer = csv.DictWriter(f, fieldnames=data.keys())
                if not csv_path.is_file():
                    writer.writeheader()
                writer.writerow(data)

        # Process predictions
        for i, det in enumerate(pred):  # per image
            seen += 1
            if webcam:  # batch_size >= 1
                p, im0, frame = path[i], im0s[i].copy(), dataset.count
                s += f'{i}: '
            else:
                p, im0, frame = path, im0s.copy(), getattr(dataset, 'frame', 0)

            p = Path(p)  # to Path
            save_path = str(save_dir / p.name)  # im.jpg

            s += '%gx%g ' % im.shape[2:]  # print string
            
            annotator = Annotator(im0, line_width=line_thickness, example=str(names))
            if len(det): 
                # Rescale boxes from img_size to im0 size
                det[:, :4] = scale_boxes(im.shape[2:], det[:, :4], im0.shape).round()
                
                vboxes.append((det.cpu().numpy(), im0, frame)) 
                ## ================================================================ writed by WQG
                det_tracking = Boxes(det, im0.shape).cpu().numpy()
                tracks = tracker.update(det_tracking, im0)
                
                if len(tracks) > 0:
                    det = torch.as_tensor(tracks[:, :-2])
                    tboxes.append((det, frame))
                else:
                    idmark = -1 * np.ones([det.shape[0], 1])
                    det = np.concatenate([det[:,:4], idmark, det[:, 4:]], axis=1)

                for *xyxy, id, conf, cls in reversed(det):
                    name = ('' if id==-1 else f'id:{int(id)} ') + names[int(cls)]                   
                    label = None if hide_labels else (name if hide_conf else f'{name} {conf:.2f}')
                    
                    if id >=0 and cls==0:
                        color = colors(int(cls), True)
                    elif id >=0 and cls!=0:
                        color = colors(int(id), True)
                    else:
                        color = colors(19, True)     # 19为调色板的最后一个元素
           
                    annotator.box_label(xyxy, label, color=color)

            # Save results (image and video with tracking)
            im0 = annotator.result()
            if save_img:
                save_path_img, ext = os.path.splitext(save_path)
                imgpath = save_path_img + f"_{dataset.frame}.png"
                cv2.imwrite(Path(imgpath), im0)
                
                if vid_path[i] != save_path:  # new video
                    vid_path[i] = save_path
                    if isinstance(vid_writer[i], cv2.VideoWriter):
                        vid_writer[i].release()  # release previous video writer
                    if vid_cap:  # video
                        fps = vid_cap.get(cv2.CAP_PROP_FPS)
                        w = int(vid_cap.get(cv2.CAP_PROP_FRAME_WIDTH))
                        h = int(vid_cap.get(cv2.CAP_PROP_FRAME_HEIGHT))
                    else:  # stream
                        fps, w, h = 30, im0.shape[1], im0.shape[0]
                    save_path = str(Path(save_path).with_suffix('.mp4'))  # force *.mp4 suffix on results videos
                    vid_writer[i] = cv2.VideoWriter(save_path, cv2.VideoWriter_fourcc(*'mp4v'), fps, (w, h))
                vid_writer[i].write(im0)

        # Print time (inference-only)
        LOGGER.info(f"{s}{'' if len(det) else '(no detections), '}{dt[1].dt * 1E3:.1f}ms")

    
    ## ======================================================================== written by WQG
    ## tboxes: list, [(det, frame_index)]
    ## bboxes: Array, [x, y, w, h, track_id, score, cls, frame_index]

    filename = os.path.split(save_path_img)[-1]
    file, ext = os.path.splitext(filename)

    bboxes = boxes_add_fid(tboxes)  
    
    imgshow = drawtracks(bboxes, file=filename)    
    
    showpath_1 = save_path_img + "_show.png"
    cv2.imwrite(Path(showpath_1), imgshow)

    ##================================================== save .npy
    with open(f'./tracking/vboxes/{file}.pkl', 'wb') as file:
        pickle.dump(vboxes, file)
    
    
    boxes_dir = Path('./runs/boxes/')
    if not boxes_dir.exists():
        boxes_dir.mkdir(parents=True, exist_ok=True)
    bboxes_path = boxes_dir.joinpath(filename + ".npy") 
    np.save(bboxes_path, bboxes)
 

    # Print results
    t = tuple(x.t / seen * 1E3 for x in dt)  # speeds per image
    LOGGER.info(f'Speed: %.1fms pre-process, %.1fms inference, %.1fms NMS per image at shape {(1, 3, *imgsz)}' % t)
    if save_txt or save_img:
        s = f"\n{len(list(save_dir.glob('labels/*.txt')))} labels saved to {save_dir / 'labels'}" if save_txt else ''
        LOGGER.info(f"Results saved to {colorstr('bold', save_dir)}{s}")
    if update:
        strip_optimizer(weights[0])  # update model (to fix SourceChangeWarning)


def parse_opt():
    modelpath = ROOT / 'ckpts/best_158734_cls11_noaug10.pt'       # 'ckpts/best_15000_0908.pt',  'ckpts/yolov5s.pt', 'ckpts/best_20000_cls30.pt'
    
    # datapath = r"D:/datasets/ym/videos/标记视频/"   # ROOT/'data/videos',  ROOT/'data/images'   images    
    datapath = r"D:\datasets\ym\highvalue\videos"
    
    # datapath = r"D:/dcheng/videos/"
    # modelpath = ROOT / 'ckpts/yolov5s.pt' 
    
    parser = argparse.ArgumentParser()
    parser.add_argument('--weights', nargs='+', type=str, default=modelpath, help='model path or triton URL')   # 'yolov5s.pt', best_15000_0908.pt
    parser.add_argument('--source', type=str, default=datapath, help='file/dir/URL/glob/screen/0(webcam)')    # images, videos
    parser.add_argument('--data', type=str, default=ROOT / 'data/coco128.yaml', help='(optional) dataset.yaml path')
    parser.add_argument('--imgsz', '--img', '--img-size', nargs='+', type=int, default=[640], help='inference size h,w')
    parser.add_argument('--conf-thres', type=float, default=0.25, help='confidence threshold')
    parser.add_argument('--iou-thres', type=float, default=0.45, help='NMS IoU threshold')
    parser.add_argument('--max-det', type=int, default=1000, help='maximum detections per image')
    parser.add_argument('--device', default='', help='cuda device, i.e. 0 or 0,1,2,3 or cpu')
    parser.add_argument('--view-img', action='store_true', help='show results')
    parser.add_argument('--save-txt', action='store_true', help='save results to *.txt')
    parser.add_argument('--save-csv', action='store_true', help='save results in CSV format')
    parser.add_argument('--save-conf', action='store_true', help='save confidences in --save-txt labels')
    parser.add_argument('--save-crop', action='store_true', help='save cropped prediction boxes')
    parser.add_argument('--nosave', action='store_true', help='do not save images/videos')
    parser.add_argument('--classes', nargs='+', type=int, help='filter by class: --classes 0, or --classes 0 2 3')
    parser.add_argument('--agnostic-nms', action='store_true', help='class-agnostic NMS')
    parser.add_argument('--augment', action='store_true', help='augmented inference')
    parser.add_argument('--visualize', action='store_true', help='visualize features')
    parser.add_argument('--update', action='store_true', help='update all models')
    parser.add_argument('--project', default=ROOT / 'runs/detect', help='save results to project/name')
    parser.add_argument('--name', default='exp', help='save results to project/name')
    parser.add_argument('--exist-ok', action='store_true', help='existing project/name ok, do not increment')
    parser.add_argument('--line-thickness', default=3, type=int, help='bounding box thickness (pixels)')
    parser.add_argument('--hide-labels', default=False, action='store_true', help='hide labels')
    parser.add_argument('--hide-conf', default=False, action='store_true', help='hide confidences')
    parser.add_argument('--half', action='store_true', help='use FP16 half-precision inference')
    parser.add_argument('--dnn', action='store_true', help='use OpenCV DNN for ONNX inference')
    parser.add_argument('--vid-stride', type=int, default=1, help='video frame-rate stride')
    opt = parser.parse_args()
    opt.imgsz *= 2 if len(opt.imgsz) == 1 else 1  # expand
    print_args(vars(opt))
    return opt

def main_loop_folders(opt):
    path1 = r"D:\datasets\ym\videos\标记视频" 
    path2 = r"D:\datasets\ym\永辉双摄视频\退购_前摄\videos"
    path3 = r"D:\datasets\ym\永辉双摄视频\退购_后摄\videos"
    path4 = r"D:\datasets\ym\永辉双摄视频\加购_前摄\videos"
    path5 = r"D:\datasets\ym\永辉双摄视频\加购_后摄\videos"
    paths = [path1]   # [path1, path2, path3, path4, path5]
    
    check_requirements(ROOT / 'requirements.txt', exclude=('tensorboard', 'thop'))
    optdict = vars(opt)
    k = 0
    for p in paths:
        files = []
        if os.path.isdir(p):
            files.extend(sorted(glob.glob(os.path.join(p, '*.*'))))
            for file in files:
                # file = r"D:\datasets\ym\videos\标记视频\加购_100.mp4"
                
                optdict["source"] = file
                run(**optdict)
                
                # k += 1
                # if k == 100:
                #     break
        elif os.path.isfile(p):
            run(**optdict)
        



def main(opt):
    check_requirements(ROOT / 'requirements.txt', exclude=('tensorboard', 'thop'))
    # files.extend(sorted(glob.glob(os.path.join(p, '*.*'))))

    optdict = vars(opt)
    p = optdict["source"]
    
    files = []
    k = 0
    if os.path.isdir(p):
        files.extend(sorted(glob.glob(os.path.join(p, '*.*'))))
        
        for file in files:
            optdict["source"] = file
            run(**optdict)
            
            k += 1
            if k == 100:
                break
            
    elif os.path.isfile(p):
        run(**vars(opt))


if __name__ == '__main__':
    opt = parse_opt()
    main_loop_folders(opt)
